﻿using System;
using System.ComponentModel;
using System.Diagnostics;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Drawing.Imaging;
using System.Runtime.InteropServices;
using System.Windows.Forms;
using Crack;

namespace QQZhaoCha
{
    public class Form1 : Form
    {
        private readonly Bitmap monImg = new Bitmap(100, 10);
        private bool _boolProcRunning;
        private bool _boolRunning;
        private int _intRefreshCount;
        private Process[] _process;
        private BackgroundWorker backgroundWorker1;
        private Button btnAutoZhaoCha;
        private Button btnLeftOffSet;
        private Button btnRightOffSet;
        private Button btnZhaoCha;
        private IContainer components;
        private Label lblDebug;
        private Label lblHotKey;
        private Label lblOffSet;
        private Label lblVersion;
        private PictureBox picResult;
        private SelectScreen SelectForm;
        private Image showImg;
        private Timer timer1;
        private WebBrowser webBrowser1;

        public Form1()
        {
            SetPos();
            InitializeComponent();
            timer1.Start();
        }

        private void backgroundWorker1_DoWork(object sender, DoWorkEventArgs e)
        {
        }

        private void btnAutoZhaoCha_Click(object sender, EventArgs e)
        {

            SetPos();
            timer1.Start();
            //picResult.Image = null;
            //if (!ProgramRunning())
            //{
            //    MessageBox.Show("未打开QQ找茬！");
            //}
            //else
            //{
            //    timer1.Start();
            //}
            //_intRefreshCount++;
            //if ((_intRefreshCount%100) == 0)
            //{
            //    webBrowser1.Refresh();
            //}
        }

        private void btnLeftOffSet_Click(object sender, EventArgs e)
        {
            int num = int.Parse(lblOffSet.Text);
            CompareOffSet(num - 1);
        }

        private void btnRightOffSet_Click(object sender, EventArgs e)
        {
            int num = int.Parse(lblOffSet.Text);
            CompareOffSet(num + 1);
        }

        private void btnZhaoCha_Click(object sender, EventArgs e)
        {
            picResult.Image = null;
            int width = Screen.AllScreens[0].Bounds.Width;
            int height = Screen.AllScreens[0].Bounds.Height;
            Image image = new Bitmap(width, height);
            Graphics.FromImage(image).CopyFromScreen(new Point(0, 0), new Point(0, 0), Screen.AllScreens[0].Bounds.Size);
            SelectForm = new SelectScreen();
            SelectForm.BackgroundImage = image;
            SelectForm.Show();
            SelectForm.FormClosed += SelectForm_FormClosed;
            btnLeftOffSet.Enabled = false;
            btnRightOffSet.Enabled = false;
            lblOffSet.Text = "0";
        }

        private void CompareOffSet(int intOffSet)
        {
            lblOffSet.Text = intOffSet.ToString();
            Bitmap bmpScreen = SelectForm.bmpScreen;
            var image = new Bitmap(380, 0x11d);
            int num = 0;
            for (int i = SelectForm.intX1; i < (SelectForm.intX1 + 380); i++)
            {
                for (int j = SelectForm.intY1; j < (SelectForm.intY1 + 0x11d); j++)
                {
                    if (SelectForm.InSelectBox(new Point(i, j)) && (j != SelectForm.intY2))
                    {
                        Color pixel = bmpScreen.GetPixel(i, j);
                        Color color2 = bmpScreen.GetPixel((i + 0x188) + intOffSet, j);
                        if (pixel != color2)
                        {
                            num++;
                            image.SetPixel(i - SelectForm.intX1, j - SelectForm.intY1, Color.Black);
                        }
                    }
                    if (num > 0xc350)
                    {
                        break;
                    }
                }
                if (num > 0xc350)
                {
                    break;
                }
            }
            showImg = new Bitmap(0x98, 0x72);
            Graphics graphics = Graphics.FromImage(showImg);
            graphics.InterpolationMode = InterpolationMode.High;
            graphics.SmoothingMode = SmoothingMode.HighQuality;
            graphics.Clear(Color.White);
            graphics.DrawImage(image, new Rectangle(0, 0, showImg.Width, showImg.Height),
                               new Rectangle(0, 0, 380, 0x11d), GraphicsUnit.Pixel);
            picResult.Image = showImg;
        }

        private void ComparePic(Bitmap bmpWindow)
        {
            try
            {
                //int num = 0;
                //for (int i = 0; i < 100; i++)
                //{
                //    for (int j = 0; j < 10; j++)
                //    {
                //        Color pixel = bmpWindow.GetPixel(i, j);
                //        Color color2 = monImg.GetPixel(i, j);
                //        monImg.SetPixel(i, j, pixel);
                //        if (pixel.ToArgb() != color2.ToArgb())
                //        {
                //            num++;
                //        }
                //    }
                //}
                if (true)
                {
                    Color color0 = bmpWindow.GetPixel(3, 270);
                    int num4 = 0x30d4;
                    int num5 = 0;
                    for (int k = 0; k < 20; k++)
                    {
                        //Color color3 = bmpWindow.GetPixel(k, 0x10);
                        Color color4 = bmpWindow.GetPixel(k, 270);
                        if (color4.ToArgb() == color0.ToArgb())
                        {
                            num5++;
                        }
                        else if (num5 > 0)
                        {
                            num5 = k;
                            break;
                        }
                    }
                    int num7 = 0;
                    int num8 = 0;
                    int num9 = 0;
                    for (int m = 380; m < 410; m++)
                    {
                        //Color color5 = bmpWindow.GetPixel(m, 0x10);
                        Color color6 = bmpWindow.GetPixel(m, 270);
                        if (color6.ToArgb() == color0.ToArgb())
                        {
                            num9++;
                            if (num7 == 0)
                            {
                                num7 = m;
                            }
                        }
                        else if ((num7 > 0) && (num8 == 0))
                        {
                            num8 = m;
                        }
                    }
                    num9 -= 12;
                    int num11 = 0;
                    color0 = bmpWindow.GetPixel(100, 0);
                    for (int n = 0; n < 15; n++)
                    {
                        Color color7 = bmpWindow.GetPixel(100, n);
                        Color color8 = bmpWindow.GetPixel(580, n);
                        //if (((color7.ToArgb() == -5206808) && (color8.ToArgb() == -5206808)) ||
                        //    ((color7.ToArgb() == -5205784) && (color8.ToArgb() == -5205784)))
                        if (color7.ToArgb() == color0.ToArgb() && color8.ToArgb() == color0.ToArgb())
                        {
                            num11++;
                        }
                    }
                    lblOffSet.Text = num9.ToString();
                    var image = new Bitmap(380, 0x11d);
                    int num13 = 0;
                    for (int num14 = num5; num14 < (num7 - num5); num14++)
                    {
                        for (int num15 = num11; num15 < ((num11 + 0x11d) - 1); num15++)
                        {
                            Color color9 = bmpWindow.GetPixel(num14, num15);
                            Color color10 = bmpWindow.GetPixel((num8 + num14) - num5, num15);
                            if (color9 != color10)
                            {
                                num13++;
                                image.SetPixel(num14 - num5, num15 - num11, Color.Green);
                                image.SetPixel((num14 - num5) + 1, num15 - num11, Color.Green);
                                image.SetPixel(num14 - num5, (num15 - num11) + 1, Color.Green);
                                image.SetPixel((num14 - num5) + 1, (num15 - num11) + 1, Color.Green);
                            }
                            else
                            {
                                Color color = Color.FromArgb(230, color9.R, color9.G, color9.B);
                                image.SetPixel(num14 - num5, num15 - num11, color);
                            }
                            num15++;
                            if (num13 > num4)
                            {
                                break;
                            }
                        }
                        num14++;
                        if (num13 > num4)
                        {
                            break;
                        }
                    }

                    showImg = new Bitmap(0x98, 0x72);
                    Graphics graphics = Graphics.FromImage(showImg);
                    graphics.InterpolationMode = InterpolationMode.High;
                    graphics.SmoothingMode = SmoothingMode.HighQuality;
                    graphics.Clear(Color.White);
                    graphics.DrawImage(image, new Rectangle(0, 0, showImg.Width, showImg.Height),
                                       new Rectangle(0, 0, 380, 0x11d), GraphicsUnit.Pixel);
                    picResult.Image = showImg;

                    ////显示到屏幕
                    //IntPtr dc1 = CreateDC("DISPLAY", null, null, (IntPtr)null);
                    ////创建显示器的DC   
                    //Graphics g1 = Graphics.FromHdc(dc1);
                    //g1.DrawImage(image, new Rectangle(3, 184, 380, 0x11d),
                    //          new Rectangle(0, 0, 380, 0x11d), GraphicsUnit.Pixel);
                    //picResult.Image = showImg;
                }
            }
            catch (Exception)
            {
            }
        }

        private void CompareWork()
        {
            _boolRunning = true;
            bool flag = false;
            int length = _process.Length;
            for (int i = 0; i < length; i++)
            {
                if (!flag)
                {
                    Process process = _process[i];
                    //string mainWindowTitle = process.MainWindowTitle;
                    //string processName = process.ProcessName;
                    //IntPtr mainWindowHandle = process.MainWindowHandle;
                    //var windowScreen = GetWindowScreen(mainWindowHandle) as Bitmap;
                    Bitmap windowScreen = GetScpic();
                    ComparePic(windowScreen);
                    flag = true;
                }
            }
            _boolRunning = false;
        }

        protected override void Dispose(bool disposing)
        {
            if (disposing && (components != null))
            {
                components.Dispose();
            }
            base.Dispose(disposing);
        }

        private void Form1_FormClosed(object sender, FormClosedEventArgs e)
        {
            UnregisterHotKey(base.Handle, base.GetType().GetHashCode());
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            if (ProgramRunning())
            {
                _boolProcRunning = true;
                bool flag = false;
                for (int i = 0; i < 1; i++)
                {
                    if (!flag)
                    {
                        Process process = _process[i];
                        string mainWindowTitle = process.MainWindowTitle;
                        string processName = process.ProcessName;
                        IntPtr mainWindowHandle = process.MainWindowHandle;
                        var rect = new ScreenCapture.User32.RECT();
                        var capture = new ScreenCapture();
                        ScreenCapture.User32.GetWindowRect(mainWindowHandle, ref rect);
                        capture.LocateWindow(mainWindowHandle);
                        if (((base.Right >= capture.WindowLeftPix) && (base.Left <= capture.WindowRightPix)) ||
                            ((base.Top >= capture.WindowBottomPix) && (base.Bottom <= capture.WindowTopPix)))
                        {
                            MessageBox.Show("请不要把外挂遮挡QQ找茬窗口！");
                        }
                        flag = true;
                    }
                }
            }
            else
            {
                //MessageBox.Show("未打开QQ找茬！");
                //Environment.Exit(Environment.ExitCode);
            }
            RegisterHotKey(base.Handle, base.GetType().GetHashCode(), 3, 0x58);
        }

        private Image GetWindowScreen(IntPtr ProcHandler)
        {
            var rect = new ScreenCapture.User32.RECT();
            var capture = new ScreenCapture();
            ScreenCapture.User32.GetWindowRect(ProcHandler, ref rect);
            return capture.CaptureWindow(ProcHandler);
        }

        private void InitializeComponent()
        {
            components = new Container();
            picResult = new PictureBox();
            btnZhaoCha = new Button();
            lblVersion = new Label();
            btnLeftOffSet = new Button();
            btnRightOffSet = new Button();
            lblOffSet = new Label();
            btnAutoZhaoCha = new Button();
            lblHotKey = new Label();
            webBrowser1 = new WebBrowser();
            lblDebug = new Label();
            timer1 = new Timer(components);
            backgroundWorker1 = new BackgroundWorker();
            ((ISupportInitialize) picResult).BeginInit();
            base.SuspendLayout();
            picResult.BackColor = Color.White;
            picResult.BorderStyle = BorderStyle.FixedSingle;
            picResult.Location = new Point(2, 2);
            picResult.Name = "picResult";
            picResult.Size = new Size(0x98, 0x72);
            picResult.TabIndex = 0;
            picResult.TabStop = false;
            btnZhaoCha.Location = new Point(0x2d, 0xa7);
            btnZhaoCha.Name = "btnZhaoCha";
            btnZhaoCha.Size = new Size(60, 0x17);
            btnZhaoCha.TabIndex = 3;
            btnZhaoCha.Text = "";
            btnZhaoCha.UseVisualStyleBackColor = true;
            btnZhaoCha.Click += btnZhaoCha_Click;
            lblVersion.AutoSize = true;
            lblVersion.Location = new Point(4, 155);
            lblVersion.Name = "lblVersion";
            lblVersion.Size = new Size(0x95, 12);
            lblVersion.TabIndex = 7;
            lblVersion.Text = " By:\n shadowk \n qq:50248291 \n 网上改编版 \n 感谢 凌云霄天翔的原版 \n\n 请保持qq找茬在左上角 \n\n 可直接在上方小图中点击";
            btnLeftOffSet.Enabled = false;
            btnLeftOffSet.Location = new Point(0x18, 0xc2);
            btnLeftOffSet.Name = "btnLeftOffSet";
            btnLeftOffSet.Size = new Size(40, 0x17);
            btnLeftOffSet.TabIndex = 4;
            btnLeftOffSet.Text = "<<";
            btnLeftOffSet.UseVisualStyleBackColor = true;
            btnLeftOffSet.Click += btnLeftOffSet_Click;
            btnRightOffSet.Enabled = false;
            btnRightOffSet.Location = new Point(0x57, 0xc2);
            btnRightOffSet.Name = "btnRightOffSet";
            btnRightOffSet.Size = new Size(40, 0x17);
            btnRightOffSet.TabIndex = 6;
            btnRightOffSet.Text = ">>";
            btnRightOffSet.UseVisualStyleBackColor = true;
            btnRightOffSet.Click += btnRightOffSet_Click;
            lblOffSet.AutoSize = true;
            lblOffSet.Location = new Point(70, 0xc7);
            lblOffSet.Name = "lblOffSet";
            lblOffSet.Size = new Size(11, 12);
            lblOffSet.TabIndex = 5;
            lblOffSet.Text = "0";
            btnAutoZhaoCha.Location = new Point(40, 0x7a);
            btnAutoZhaoCha.Name = "btnAutoZhaoCha";
            btnAutoZhaoCha.Size = new Size(0x4b, 0x17);
            btnAutoZhaoCha.TabIndex = 1;
            btnAutoZhaoCha.Text = "开始找茬";
            btnAutoZhaoCha.UseVisualStyleBackColor = true;
            btnAutoZhaoCha.Click += btnAutoZhaoCha_Click;
            lblHotKey.AutoSize = true;
            lblHotKey.Location = new Point(0x2c, 0x93);
            lblHotKey.Name = "lblHotKey";
            lblHotKey.Size = new Size(0x41, 12);
            lblHotKey.TabIndex = 2;
            lblHotKey.Text = "Ctrl+Alt+X";
            webBrowser1.Location = new Point(0x13, 0xea);
            webBrowser1.MinimumSize = new Size(20, 20);
            webBrowser1.Name = "webBrowser1";
            webBrowser1.ScrollBarsEnabled = false;
            webBrowser1.Size = new Size(120, 60);
            webBrowser1.TabIndex = 8;
            webBrowser1.Url = new Uri("http://www.pryko.com/QQZhaoCha.htm", UriKind.Absolute);
            webBrowser1.WebBrowserShortcutsEnabled = false;
            lblDebug.AutoSize = true;
            lblDebug.Location = new Point(0x37, 0xff);
            lblDebug.Name = "lblDebug";
            lblDebug.Size = new Size(0, 12);
            lblDebug.TabIndex = 9;
            timer1.Interval = 1000;
            timer1.Tick += timer1_Tick;
            backgroundWorker1.DoWork += backgroundWorker1_DoWork;
            AutoScaleDimensions = new SizeF(6f, 12f);
            AutoScaleMode = AutoScaleMode.Font;
            picResult.MouseClick += new MouseEventHandler(picResult_MouseClick);
            ClientSize = new Size(0x9c, 0x120);
            Controls.Add(lblDebug);
            //Controls.Add(webBrowser1);
            //Controls.Add(lblHotKey);
            Controls.Add(btnAutoZhaoCha);
            //Controls.Add(lblOffSet);
            //Controls.Add(btnRightOffSet);
            //Controls.Add(btnLeftOffSet);
            Controls.Add(lblVersion);
            //Controls.Add(btnZhaoCha);
            Controls.Add(picResult);
            MaximizeBox = false;
            Name = "Form1";
            Text = "QQ找茬";
            this.Location = new System.Drawing.Point(810, 200);
            this.StartPosition = System.Windows.Forms.FormStartPosition.Manual;
            Load += Form1_Load;
            FormClosed += Form1_FormClosed;
            ((ISupportInitialize) picResult).EndInit();
            ResumeLayout(false);
            PerformLayout();
        }

        private void picResult_MouseClick(object sender, MouseEventArgs e)
        {
            int srcX = 3 + 5;
            int srcY = 184 + 5;
            //0x98, 0x72  = 152, 114
            //380, 0x11d  = 380,285 
            float bx = (float)380/152;
            float by = (float)285 / 114;

            int tx = srcX + (int)(e.X*bx);
            int ty = srcY + (int)(e.Y*by);

            Point point = new Point();
            GetCursorPos(ref point);

            SetCursorPos(tx, ty);
            mouse_event(MouseEventFlag.LeftDown, 0, 0, 0, UIntPtr.Zero);
            mouse_event(MouseEventFlag.LeftUp, 0, 0, 0, UIntPtr.Zero);

            SetCursorPos(point.X, point.Y);
        }

        private bool ProgramRunning()
        {
            bool flag = true;
            if (_boolProcRunning)
            {
                return flag;
            }
            _process = Process.GetProcessesByName("zhaocha");
            int length = _process.Length;
            if (length > 0)
            {
                return flag;
            }
            flag = false;
            _process = Process.GetProcessesByName("大家来找茬");
            length = _process.Length;
            if (length <= 0)
            {
                _process = Process.GetProcessesByName("大家来~1");
                length = _process.Length;
                if (length <= 0)
                {
                    return false;
                }
                return true;
            }
            return true;
        }

        private void SelectForm_FormClosed(object sender, FormClosedEventArgs e)
        {
            showImg = SelectForm.showImg;
            picResult.Image = showImg;
            lblOffSet.Text = SelectForm.intMinOffSet.ToString();
            btnLeftOffSet.Enabled = true;
            btnRightOffSet.Enabled = true;
        }

        private void ShowDebug(string strDebug)
        {
            lblDebug.Text = strDebug;
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            try
            {
                if (!_boolRunning)
                {
                    CompareWork();
                }
            }
            catch (Exception)
            {
                timer1.Stop();
            }
        }

        protected override void WndProc(ref Message m)
        {
            if (m.Msg == 0x312)
            {
                base.Activate();
                btnAutoZhaoCha_Click(this, EventArgs.Empty);
            }
            base.WndProc(ref m);
        }

        protected static Bitmap GetScpic()
        {
            IntPtr dc1 = CreateDC("DISPLAY", null, null, (IntPtr)null);
            //创建显示器的DC   
            Graphics g1 = Graphics.FromHdc(dc1);

            //由一个指定设备的句柄创建一个新的Graphics对象   
            Bitmap MyImage = new Bitmap(Screen.PrimaryScreen.Bounds.Width, Screen.PrimaryScreen.Bounds.Height, g1);
            //根据屏幕大小创建一个与之相同大小的Bitmap对象   
            Graphics g2 = Graphics.FromImage(MyImage);
            //获得屏幕的句柄   
            IntPtr dc3 = g1.GetHdc();
            //获得位图的句柄   
            IntPtr dc2 = g2.GetHdc();
            //把当前屏幕捕获到位图对象中   
            BitBlt(dc2, 0, 0, Screen.PrimaryScreen.Bounds.Width, Screen.PrimaryScreen.Bounds.Height, dc3, 0, 0, 13369376);
            //把当前屏幕拷贝到位图中   
            g1.ReleaseHdc(dc3);
            //释放屏幕句柄   
            g2.ReleaseHdc(dc2);
      
            Bitmap ret = GetPart(MyImage, 3, 184, 795, 300);
            MyImage.Dispose();

            return ret;
        }

        public void SetPos()
        {
            IntPtr window = FindWindow("#32770", "大家来找茬");
            SetWindowPos(window.ToInt32(), HWND_TOPMOST, 0, 0, 800, 600, SWP_SHOWWINDOW);

            Location = new Point(810, 200);
            StartPosition = FormStartPosition.Manual;
            ClientSize = new Size(0x9c, 0x120);
        }

        public static Bitmap GetPart(Bitmap src, int x, int y, int width, int height)
        {

            Bitmap partImg = new Bitmap(width, height);
            Graphics graphics = Graphics.FromImage(partImg);
            Rectangle destRect = new Rectangle(new Point(0, 0),
                                               new Size(width, width)); //目标位置
            Rectangle origRect = new Rectangle(new Point(x, y),
                                               new Size(width, width)); //原图位置（默认从原图中截取的图片大小等于目标图片的大小）

            graphics.DrawImage(src, destRect, origRect, GraphicsUnit.Pixel);
            return partImg;
        }

        protected override void OnClosed(EventArgs e)
        {
            base.OnClosed(e);
            Environment.Exit(Environment.ExitCode);
        }

        #region Api

        [DllImport("user32.dll")]
        public static extern bool RegisterHotKey(IntPtr hWnd, int id, int fsModifiers, int vlc);

        [DllImport("user32.dll")]
        public static extern bool UnregisterHotKey(IntPtr hWnd, int id);


        [DllImport("user32.dll", EntryPoint = "SetWindowPos")]
        public static extern int SetWindowPos(int hWnd, int hWndInsertAfter, int x, int y, int cx, int cy, int wFlags);

        const int HWND_TOPMOST = -1;
        const int SWP_SHOWWINDOW = 40;

        [Flags]
        enum MouseEventFlag : uint
        {
            Move = 0x0001,
            LeftDown = 0x0002,
            LeftUp = 0x0004,
            RightDown = 0x0008,
            RightUp = 0x0010,
            MiddleDown = 0x0020,
            MiddleUp = 0x0040,
            XDown = 0x0080,
            XUp = 0x0100,
            Wheel = 0x0800,
            VirtualDesk = 0x4000,
            Absolute = 0x8000
        }

        [DllImport("user32.dll")]
        static extern bool SetCursorPos(int X, int Y);

        [DllImport("user32.dll")]
        public static extern short GetCursorPos(ref   System.Drawing.Point point);

        [DllImport("user32.dll")]
        static extern void mouse_event(MouseEventFlag flags, int dx, int dy, uint data, UIntPtr extraInfo);

        [System.Runtime.InteropServices.DllImportAttribute("gdi32.dll")]
        private static extern bool BitBlt(
        IntPtr hdcDest,   //目标设备的句柄   
        int nXDest,   //   目标对象的左上角的X坐标   
        int nYDest,   //   目标对象的左上角的X坐标   
        int nWidth,   //   目标对象的矩形的宽度   
        int nHeight,   //   目标对象的矩形的长度   
        IntPtr hdcSrc,   //   源设备的句柄   
        int nXSrc,   //   源对象的左上角的X坐标   
        int nYSrc,   //   源对象的左上角的X坐标   
        System.Int32 dwRop   //   光栅的操作值   
        );

        [System.Runtime.InteropServices.DllImportAttribute("gdi32.dll")]
        private static extern IntPtr CreateDC(
        string lpszDriver,   //   驱动名称   
        string lpszDevice,   //   设备名称   
        string lpszOutput,   //   无用，可以设定位"NULL"   
        IntPtr lpInitData   //   任意的打印机数据   
        );

        [DllImport("user32.dll", EntryPoint = "FindWindow")]
        public static extern IntPtr FindWindow(
        string lpClassName,
        string lpWindowName
        );
        #endregion

 
    }
}